#include "defs.h"
#include "crypt.h"

void encryptUserEntry(struct dbUsers *Entry, BF_KEY *Key)
{
  BF_KEY key;
  unsigned char ivec;
  int num;

  strcpy(Entry->CryptID, "US0");
  memcpy(&key, Key, sizeof(key)); ivec = 0; num = 0;
  BF_cfb64_encrypt(Entry->CryptID, Entry->CryptID, 4, &key, &ivec, &num, BF_ENCRYPT);

  memcpy(&key, Key, sizeof(key)); ivec = 0; num = 0;
  BF_cfb64_encrypt(Entry->UserName, Entry->UserName, MAX_USERNAME_SIZE + 1, &key, &ivec, &num, BF_ENCRYPT);

  memcpy(&key, Key, sizeof(key)); ivec = 0; num = 0;
  BF_cfb64_encrypt(Entry->Password, Entry->Password, MAX_PASSWORD_SIZE + 1, &key, &ivec, &num, BF_ENCRYPT);

  memcpy(&key, Key, sizeof(key)); ivec = 0; num = 0;
  BF_cfb64_encrypt(Entry->Comment, Entry->Comment, MAX_COMMENT_SIZE + 1, &key, &ivec, &num, BF_ENCRYPT);
}

/* Result 1 = okay */
/* Result 0 = error */
int decryptUserEntry(struct dbUsers *Entry, BF_KEY *Key)
{
  BF_KEY key;
  unsigned char ivec;
  int num;
  memcpy(&key, Key, sizeof(key)); ivec = 0; num = 0;
  BF_cfb64_encrypt(Entry->CryptID, Entry->CryptID, 4, &key, &ivec, &num, BF_DECRYPT);
  memcpy(&key, Key, sizeof(key)); ivec = 0; num = 0;
  BF_cfb64_encrypt(Entry->UserName, Entry->UserName, MAX_USERNAME_SIZE + 1, &key, &ivec, &num, BF_DECRYPT);

  memcpy(&key, Key, sizeof(key)); ivec = 0; num = 0;
  BF_cfb64_encrypt(Entry->Password, Entry->Password, MAX_PASSWORD_SIZE + 1, &key, &ivec, &num, BF_DECRYPT);

  memcpy(&key, Key, sizeof(key)); ivec = 0; num = 0;
  BF_cfb64_encrypt(Entry->Comment, Entry->Comment, MAX_COMMENT_SIZE + 1, &key, &ivec, &num, BF_DECRYPT);

  Entry->UserName[MAX_USERNAME_SIZE] = '\0';
  Entry->Password[MAX_PASSWORD_SIZE] = '\0';
  Entry->Comment[MAX_COMMENT_SIZE] = '\0';

  if (strcmp(Entry->CryptID, "USR") == 0) return(ERR_OLD_DB);
  if (strcmp(Entry->CryptID, "US0")) return(0);
  return(1);
}

void encryptHostEntry(struct dbHosts *Entry, BF_KEY *Key)
{
  BF_KEY key;
  unsigned char ivec;
  int num;

  strcpy(Entry->CryptID, "HS1");
  memcpy(&key, Key, sizeof(key)); ivec = 0; num = 0;
  BF_cfb64_encrypt(Entry->CryptID, Entry->CryptID, 4, &key, &ivec, &num, BF_ENCRYPT);

  memcpy(&key, Key, sizeof(key)); ivec = 0; num = 0;
  BF_cfb64_encrypt(Entry->HostName, Entry->HostName, MAX_HOSTNAME_SIZE + 1, &key, &ivec, &num, BF_ENCRYPT);

  memcpy(&key, Key, sizeof(key)); ivec = 0; num = 0;
  BF_cfb64_encrypt(Entry->Comment, Entry->Comment, MAX_COMMENT_SIZE + 1, &key, &ivec, &num, BF_ENCRYPT);
}

int decryptHostEntry(struct dbHosts *Entry, BF_KEY *Key)
{
  BF_KEY key;
  unsigned char ivec;
  int num;

  memcpy(&key, Key, sizeof(key)); ivec = 0; num = 0;
  BF_cfb64_encrypt(Entry->CryptID, Entry->CryptID, 4, &key, &ivec, &num, BF_DECRYPT);

  memcpy(&key, Key, sizeof(key)); ivec = 0; num = 0;
  BF_cfb64_encrypt(Entry->HostName, Entry->HostName, MAX_HOSTNAME_SIZE + 1, &key, &ivec, &num, BF_DECRYPT);
  Entry->HostName[MAX_HOSTNAME_SIZE] = '\0';

  memcpy(&key, Key, sizeof(key)); ivec = 0; num = 0;
  BF_cfb64_encrypt(Entry->Comment, Entry->Comment, MAX_COMMENT_SIZE + 1, &key, &ivec, &num, BF_DECRYPT);
  Entry->Comment[MAX_COMMENT_SIZE] = '\0';

  if (strcmp(Entry->CryptID, "HST") == 0) return(ERR_OLD_DB);
  if (strcmp(Entry->CryptID, "HS0") == 0) return(ERR_OLD_DB);
  if (strcmp(Entry->CryptID, "HS1")) return(ERR_DECRYPTION);

  return(1);
}
