#ifndef __DEFS_H__
#define __DEFS_H__

/* Misc */
#define VERSION         "0.93a"
#define TRUE		1
#define FALSE		0
#define NTRUE		FALSE
#define NFALSE		TRUE

/* Database */
#define MAX_HOSTS       1024  /* Maximum allowed Hosts in Database */
#define MAX_USERS       128   /* Maximum allowed Users per Host */

#define MAX_HOSTNAME_SIZE       50  /* Maximum allowed size of Hostname */
#define MAX_USERNAME_SIZE       30  /* Maximum allowed size of Username */
#define MAX_PASSWORD_SIZE       30  /* Maximum allowed size of Password */
#define MAX_COMMENT_SIZE        60  /* Maximum allowed size of Comment */

/* Errors */
#define ERR_NO_ERROR		 0	/* No Error */
#define ERR_DB_NOT_EXIST	-1	/* Database does not exist yet */
#define ERR_DECRYPTION		-2	/* Decryption error (Wrong Password?) */
#define ERR_HOST_EXIST		-3	/* Host already exist */
#define ERR_HOST_NOT_EXIST	-4	/* Host does not exist */
#define ERR_HOSTNAME_NOT_VALID	-5	/* Hostname is not valid */
#define ERR_USERS_EXIST		-6	/* Cannot delete because users exist */
#define ERR_OLD_DB		-7	/* Old Host database. */
#define ERR_OLD_OLD_DB		-8	/* Old old Host database */
#define ERR_MAX_HOSTS_REACHED	-10	/* MAX_HOSTS reached */
#define ERR_USER_EXIST		-11	/* User already exist */
#define ERR_USER_NOT_EXIST	-12	/* User does not exist */
#define ERR_USERNAME_NOT_VALID	-13	/* Username is not valid */
#define ERR_MAX_USERS_REACHED	-20	/* MAX_USERS for Host reached */

#endif
