#include <cdk.h>
#include "db.h"

#ifndef __UI_H__
#define __UI_H__

static char *okaybtn[] = {" Okay "};
static char *yesno[] = {" Yes ", " No "};

/* show a window with the text "Progressing..." */
void showProgress(CDKSCREEN *cdkscreen);

/* hide the window */
void hideProgress(CDKSCREEN *cdkscreen);

/* show/modify user info mask */
int UserInfoMask(CDKSCREEN *cdkscreen, char *Username, char *Password, char *Comment, int ShowOnly);

/* an input box */
char *InputBox(CDKSCREEN *cdkscreen, int xpos, int ypos, int width, char *title, char *label, char *preVal, int maxLen);

/* another input box that does not echo users input */
char *pwdInputBox(CDKSCREEN *cdkscreen, int xpos, int ypos, int width, char *title, char *label, int maxLen);

/* the main menu */
int MainMenu(CDKSCREEN *cdkscreen);

/* the user menu */
int UserMenu(CDKSCREEN *cdkscreen, char *HostName);

/* show a sorted list of hosts */
char *listHosts(CDKSCREEN *cdkscreen, struct dbHosts Hosts[], int HostCount);

/* show a sorted list of users */
int listUsers(CDKSCREEN *cdkscreen, struct dbUsers Users[], int UserCount);

/* Process function for listUsers/listHosts */
int ProcessList(EObjectType cdktype, CDKSCROLL *object, CDKENTRY *clientData, chtype input);

#endif
