#include "defs.h"
#include "pms_lookup.h"

int lookup_main(char *complete)
{
  char HostName[MAX_HOSTNAME_SIZE + 1];
  char UserName[MAX_USERNAME_SIZE + 1];
  char Password[MAX_PASSWORD_SIZE + 1];
  char *pw;
  char *atpos;
  int result;
  BF_KEY key;
  struct dbHosts Host;
  struct dbUsers User;


  printVersion();

  atpos = (char *) strstr(complete, "@");
  atpos += 1;

  strncpy(HostName, atpos, MAX_HOSTNAME_SIZE);
  strncpy(UserName, complete, MAX_USERNAME_SIZE);
  atpos = (char *) (atpos - complete);
  atpos = atpos - 1;
  UserName[(int) atpos] = '\0';

  result = generateKey(&key, "", 1);
  if (result == ERR_DB_NOT_EXIST)
  {
    printf("Database does not exist!\n\n");
    return(-1);
  }

  pw = getpass("Database password: ");

  if (pw == NULL)
  {
    printf("getpass: cannot open /dev/tty\n\n");
    return(0);
  }

  strncpy(Password, pw, MAX_PASSWORD_SIZE);

  result = generateKey(&key, Password, 1);
  if (result < -1)
  {
    printf("Error: %s\n", errorToStr(result));
    exit(1);
  }

  printf("\n");


  strncpy(Host.HostName, HostName, MAX_HOSTNAME_SIZE);
  result = findHostEntry(&Host, &key);
  if (result < 0)
  {
    printf("Lookup \"%s\" in HostDB failed: ", HostName);
    printf("%s\n\n", errorToStr(result));
    return(result);
  }
  strncpy(User.UserName, UserName, MAX_USERNAME_SIZE);
  User.Host = result;

  result = findUserEntry(&User, &key);
  if (result < 0)
  {
    printf("Lookup \"%s\" in UserDB faild: ", UserName);
    printf("%s\n\n", errorToStr(result));
    return(result);
  }

  printf("Hostname: \"%s\"\n", Host.HostName);
  printf("Comment : \"%s\"\n\n", Host.Comment);

  printf("Username: \"%s\"\n", User.UserName);
  printf("Password: \"%s\"\n", User.Password);
  printf("Comment : \"%s\"\n\n", User.Comment);

  return(NTRUE);
}
