#include "oldstuff.h"

/* Generate a key from a password, needed by blowfish. */
int generateKey91(BF_KEY *Key, char *Password)
{
  FILE *Database;
  char HostDB[256];
  struct dbHosts91 Entry;

  BF_set_key(Key, strlen(Password), Password); /* Generate key */

  /* open database */
  getHostDB91(HostDB, "");
  strncat(HostDB, "/.pms_db_hosts", 256);
  Database = fopen(HostDB, "r");
  if (Database == NULL) return(-1);  /* Database doesn't exist yet */

  /* read an entry and check for eof */
  if (fread(&Entry, sizeof(Entry), 1, Database) == 0)
  {
    /* Database is empty */
    fclose(Database);
    return(-1);
  }

  /* decrypt entry now */
  if (!decryptHostEntry91(&Entry, Key)) {
    /* sorry, wrong password */
    fclose(Database);
    return(0);
  };

  /* all right */
  fclose(Database);
  return(1);
}

/* get the name of the host database file depending on the user logged on */
int getHostDB91(char *HostDB, char *UserName)
{
  struct passwd *pwdbuf;

  if (strcmp(UserName, "") == 0)
  {
    pwdbuf = getpwuid(getuid());
    if (pwdbuf == NULL) return(0);
    strcpy(HostDB, pwdbuf->pw_dir);
    return(1);
  } else {
    pwdbuf = getpwnam(UserName);
    if (pwdbuf == NULL) return(0);
    strcpy(HostDB, pwdbuf->pw_dir);
    return(1);
  }
}

/* Get a list of all hosts in the database */
int getHosts91(struct dbHosts91 Entrys[], BF_KEY *Key)
{
  char HostDB[256];
  FILE *Database;
  struct dbHosts91 Entry;
  int EntryNo = 0;

  /* Init variables and open database */
  getHostDB91(HostDB, "");
  strncat(HostDB, "/.pms_db_hosts", 256);
  Database = fopen(HostDB, "r");
  if (Database == NULL) return(-1); /* Database not found */

  /* read the database */
  while(!feof(Database))
  {
    /* read an entry and check for eof */
    if (fread(&Entry, sizeof(Entry), 1, Database) == 0) break;

    /* decrypt the entry */
    if (!decryptHostEntry91(&Entry, Key))
    {
     fclose(Database);
     return(-2);  /* sorry, wrong key */
    }

    /* Is the entry not deleted? */
    if (strlen(Entry.HostName) > 0)
    {
      /* no, it is'nt. put it in our list */
      if (Entrys != NULL)
      {
        memcpy(&Entrys[EntryNo], &Entry, sizeof(Entry));
        Entrys[EntryNo].HostName[MAX_HOSTNAME_SIZE91] = '\0';
      }
      EntryNo++;
    }
  }

  /* Close database and return number of founded hosts */
  fclose(Database);
  return(EntryNo);
}

/* ------ Userdb functions --------- */
/* get the name of the user database file depending on the user logged on */
int getUserDB91(char *UserDB, char *UserName)
{
  struct passwd *pwdbuf;

  if (strcmp(UserName, "") == 0)
  {
    pwdbuf = getpwuid(getuid());
    if (pwdbuf == NULL) return(0);
    strcat(strcpy(UserDB, pwdbuf->pw_dir), "/.pms_db_users");
    return(1);
  } else {
    pwdbuf = getpwnam(UserName);
    if (pwdbuf == NULL) return(0);
    strcat(strcpy(UserDB, pwdbuf->pw_dir), "/.pms_db_users");
    return(1);
  }
}

/* Get a list of all user with HostID in the database */
int getUsers91(struct dbUsers91 Entrys[], int HostID, BF_KEY *Key)
{
  char UserDB[256];
  FILE *Database;
  struct dbUsers91 Entry;
  int EntryNo = 0;

  /* Init variables and open database */
  getUserDB91(UserDB, "");
  Database = fopen(UserDB, "r");
  if (Database == NULL) return(-1);

  /* read the database */
  while(!feof(Database))
  {
    /* read an entry and check for eof */
    if (fread(&Entry, sizeof(Entry), 1, Database) == 0) break;

    /* decrypt the entry */
    if (!decryptUserEntry91(&Entry, Key))
    {
     fclose(Database);
     return(-2);  /* sorry, wrong key */
    }

    if (Entry.Host == HostID)
    {
      /* Is the entry not deleted? */
      if (strlen(Entry.UserName) > 0)
      {
        /* no, it is'nt. put it in our list */
        if (Entrys != NULL)
        {
          memcpy(&Entrys[EntryNo], &Entry, sizeof(Entry));
          Entrys[EntryNo].UserName[MAX_USERNAME_SIZE91] = '\0';
          Entrys[EntryNo].Password[MAX_PASSWORD_SIZE91] = '\0';
          Entrys[EntryNo].Comment[MAX_COMMENT_SIZE91] = '\0';
        }
        EntryNo++;
      }
    }
  }

  /* Close database and return number of founded users */
  fclose(Database);
  return(EntryNo);
}

void encryptUserEntry91(struct dbUsers91 *Entry, BF_KEY *Key)
{
  BF_KEY key;
  unsigned char ivec;
  int num;

  strcpy(Entry->CryptID, "USR");
  memcpy(&key, Key, sizeof(key)); ivec = 0; num = 0;
  BF_cfb64_encrypt(Entry->CryptID, Entry->CryptID, 4, &key, &ivec, &num, BF_ENCRYPT);

  memcpy(&key, Key, sizeof(key)); ivec = 0; num = 0;
  BF_cfb64_encrypt(Entry->UserName, Entry->UserName, MAX_USERNAME_SIZE91 + 1, &key, &ivec, &num, BF_ENCRYPT);

  memcpy(&key, Key, sizeof(key)); ivec = 0; num = 0;
  BF_cfb64_encrypt(Entry->Password, Entry->Password, MAX_PASSWORD_SIZE91 + 1, &key, &ivec, &num, BF_ENCRYPT);

  memcpy(&key, Key, sizeof(key)); ivec = 0; num = 0;
  BF_cfb64_encrypt(Entry->Comment, Entry->Comment, MAX_COMMENT_SIZE91 + 1, &key, &ivec, &num, BF_ENCRYPT);
}

int decryptUserEntry91(struct dbUsers91 *Entry, BF_KEY *Key)
{
  BF_KEY key;
  unsigned char ivec;
  int num;
  memcpy(&key, Key, sizeof(key)); ivec = 0; num = 0;
  BF_cfb64_encrypt(Entry->CryptID, Entry->CryptID, 4, &key, &ivec, &num, BF_DECRYPT);
  if (strcmp(Entry->CryptID, "USR")) return(0);

  memcpy(&key, Key, sizeof(key)); ivec = 0; num = 0;
  BF_cfb64_encrypt(Entry->UserName, Entry->UserName, MAX_USERNAME_SIZE91 + 1, &key, &ivec, &num, BF_DECRYPT);

  memcpy(&key, Key, sizeof(key)); ivec = 0; num = 0;
  BF_cfb64_encrypt(Entry->Password, Entry->Password, MAX_PASSWORD_SIZE91 + 1, &key, &ivec, &num, BF_DECRYPT);

  memcpy(&key, Key, sizeof(key)); ivec = 0; num = 0;
  BF_cfb64_encrypt(Entry->Comment, Entry->Comment, MAX_COMMENT_SIZE91 + 1, &key, &ivec, &num, BF_DECRYPT);

  Entry->UserName[MAX_USERNAME_SIZE91] = '\0';
  Entry->Password[MAX_PASSWORD_SIZE91] = '\0';
  Entry->Comment[MAX_COMMENT_SIZE91] = '\0';
  return(1);
}

void encryptHostEntry91(struct dbHosts91 *Entry, BF_KEY *Key)
{
  BF_KEY key;
  unsigned char ivec;
  int num;

  strcpy(Entry->CryptID, "HST");
  memcpy(&key, Key, sizeof(key)); ivec = 0; num = 0;
  BF_cfb64_encrypt(Entry->CryptID, Entry->CryptID, 4, &key, &ivec, &num, BF_ENCRYPT);

  memcpy(&key, Key, sizeof(key)); ivec = 0; num = 0;
  BF_cfb64_encrypt(Entry->HostName, Entry->HostName, MAX_HOSTNAME_SIZE91 + 1, &key, &ivec, &num, BF_ENCRYPT);
}

int decryptHostEntry91(struct dbHosts91 *Entry, BF_KEY *Key)
{
  BF_KEY key;
  unsigned char ivec;
  int num;

  memcpy(&key, Key, sizeof(key)); ivec = 0; num = 0;
  BF_cfb64_encrypt(Entry->CryptID, Entry->CryptID, 4, &key, &ivec, &num, BF_DECRYPT);

  if (strcmp(Entry->CryptID, "HST")) return(0);

  memcpy(&key, Key, sizeof(key)); ivec = 0; num = 0;
  BF_cfb64_encrypt(Entry->HostName, Entry->HostName, MAX_HOSTNAME_SIZE91 + 1, &key, &ivec, &num, BF_DECRYPT);
  Entry->HostName[MAX_HOSTNAME_SIZE91] = '\0';
  return(1);
}