#include "pms_passwd.h"

void convertDatabaseNew(char *Password)
{
  BF_KEY key, newkey;

  generateKey(&key, Password, 0);
  generateKey(&newkey, Password, 1);
  changePassword(&key, &newkey);
}

void convertDatabase(BF_KEY *key, char *Password)
{
  char HostDB[256];
  char HostDBNew[256];
  struct dbHosts HostNew;
  struct dbHosts91 Hosts[MAX_HOSTS];
  int HostCount;
  int i;
  FILE *Database;
  FILE *NewDatabase;

  generateKey(key, Password, 0);

  getHostDB91(HostDB, "");
  getHostDB91(HostDBNew, "");

  strncat(HostDB, "/.pms_db_hosts", 256);
  strncat(HostDBNew, "/.pms_db_hosts_new", 256);

  Database = fopen(HostDB, "r");
  NewDatabase = fopen(HostDBNew, "w");
  if (Database == NULL)
  {
    printf("Error opening Database (%s)\n", HostDB);
    exit(1);
  }

  if (NewDatabase == NULL)
  {
    printf("Error creating file ~/.pms_db_hosts_new\n");
    exit(1);
  }

  printf("Converting to database v9.2...\n");
  HostCount = getHosts91(Hosts, key);
  printf("Converting %d Hosts", HostCount);
  for(i=0; i<HostCount; i++)
  {
    printf(".");
    strcpy(HostNew.HostName, Hosts[i].HostName);
    strcpy(HostNew.Comment, "");
    HostNew.Host = Hosts[i].Host;
    encryptHostEntry(&HostNew, key);
    fwrite(&HostNew, sizeof(HostNew), 1, NewDatabase); checkWrite(NewDatabase);
  }
  fclose(Database);
  fclose(NewDatabase);
  printf("\nRename ~/.pms_db_hosts -> ~/pms_db_hosts_v91...");
  rename(HostDB, "~/pms_db_hosts_v91");
  printf("ok\n");
  printf("Rename ~/.pms_db_hosts_new -> ~/.pms_db_hosts...");
  rename(HostDBNew, HostDB);
  printf("ok\n");
  printf("done. Converting to v9.3...\n\n");
  convertDatabaseNew(Password);
  exit(0);
}

void changePassword(BF_KEY *key, BF_KEY *newkey)
{
  char HostDB[256];
  char HostDBNew[256];
  struct dbHosts Hosts[MAX_HOSTS];
  struct dbUsers Users[MAX_USERS];
  int HostCount, UserCount;
  int i;
  FILE *Database;
  FILE *NewDatabase;

  getHostDB91(HostDB, "");
  getHostDB91(HostDBNew, "");

  strncat(HostDB, "/.pms_db_hosts", 256);
  strncat(HostDBNew, "/.pms_db_hosts_new", 256);

  Database = fopen(HostDB, "r");
  NewDatabase = fopen(HostDBNew, "w");
  if (Database == NULL)
  {
    printf("Error opening Database (%s)\n", HostDB);
    exit(1);
  }

  if (NewDatabase == NULL)
  {
    printf("Error creating file (%s)\n", HostDBNew);
    exit(1);
  }

  printf("Reading old database...\n");
  HostCount = getHosts(Hosts, key);
  printf("Converting %d Hosts", HostCount);
  for(i=0; i<HostCount; i++)
  {
    printf(".");
    encryptHostEntry(&Hosts[i], newkey);
    fwrite(&Hosts[i], sizeof(Hosts[i]), 1, NewDatabase); checkWrite(NewDatabase);
  }
  fclose(Database);
  fclose(NewDatabase);
/*  printf("\nRename %s -> %s...", HostDB, strcat(HostDB, "_old"));
  rename(HostDB, strcat(HostDB, "_old")); */
  printf("ok\n");
  printf("Rename %s -> %s...", HostDBNew, HostDB);
  rename(HostDBNew, HostDB);
  printf("ok\n");

  /* - - - - - - - - - - - - - - - - - - - - - - - UserDB */

  getHostDB91(HostDB, "");
  getHostDB91(HostDBNew, "");

  strncat(HostDB, "/.pms_db_users", 256);
  strncat(HostDBNew, "/.pms_db_users_new", 256);

  Database = fopen(HostDB, "r");
  NewDatabase = fopen(HostDBNew, "w");
  if (Database == NULL)
  {
    printf("Error opening Database (%s)\n", HostDB);
    exit(1);
  }

  if (NewDatabase == NULL)
  {
    printf("Error creating file (%s)\n", HostDBNew);
    exit(1);
  }

  printf("Reading old database...\n");
  UserCount = getUsers(Users, -1, key);
  if (UserCount == 0)
  {
    printf("STOP!\n");
    exit(0);
  }
  printf("Converting %d Users", UserCount);
  for(i=0; i<UserCount; i++)
  {
    printf(".");
    encryptUserEntry(&Users[i], newkey);
    fwrite(&Users[i], sizeof(Users[i]), 1, NewDatabase); checkWrite(NewDatabase);
  }
  fclose(Database);
  fclose(NewDatabase);
  printf("\nDeleting %s...", HostDB);
  remove(HostDB);
  printf("ok\n");
  printf("Rename %s -> %s...", HostDBNew, HostDB);
  rename(HostDBNew, HostDB);
  printf("ok\n");

  exit(0);
}

int main(int argc, char **argv)
{
  char *pw;
  char *pwnew;
  char *pwrenew;
  char Password[MAX_PASSWORD_SIZE + 1];
  BF_KEY key, newkey;
  char yn;
  int convert;
  int keyres;

  pw = (char *) getpass("Old Database password: ");

  if (pw == NULL)
  {
    printf("getpass: cannot open /dev/tty\n\n");
    return(0);
  }

  strncpy(Password, pw, MAX_PASSWORD_SIZE);
  keyres = generateKey(&key, Password, 1);

  convert = 0;
  switch(keyres)
  {
    case -1: /* Database not exist */
      printf("Sorry. Database not exist.\n\n");
      exit(1);
      break;
    case -2: /* Wrong password */
        printf("Sorry. Wrong password!\n\n");
        exit(2);
      break;
    case -7: /* Convert Database */
        convert = 2; /* Convert v0.92 Database */
      break;
    case -8:
        convert = 1; /* Convert v0.91 Database */
      break;
  }

  if (!convert)
  {
    pwnew = (char *) getpass("New Database password: ");
    pwrenew = (char *) getpass("Retype password: ");

    if (strcmp(pwnew, pwrenew))
    {
      printf("Passwords does not match\n");
      exit(1);
    }

    strncpy(Password, pwnew, MAX_PASSWORD_SIZE);
    generateKey(&newkey, Password, 1);
    changePassword(&key, &newkey);
  } else {
    printf("\nYour Database-structure must be converted.\n\n");
    if (convert == 1)
    {
      printf("WARNING: Converting from v9.1 to v9.3 has NOT been TESTED!\n");
      printf("         Backup the files\n");
      printf("           ~/.pms_db_hosts\n");
      printf("           ~/.pms_db_users\n");
      printf("         before you proceed!\n\n");
    }
    printf("Do you want to do it now? (y/N) ");
    yn = getchar();
    if (yn != 'y' && yn != 'Y')
    {
      printf("Aborted.\n");
      exit(0);
    }

    if (convert == 1)
    {
      convertDatabase(&key, Password);
    }
    if (convert == 2) convertDatabaseNew(Password);
  }
}
